﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public SQL1 As SQL
	Public SQLDataBasePath As String
	Public SQLDateBaseName As String
'	Public SQLTableName As String
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	'initialize the variables
	'need to
	'1 copy db from assets on firsttime
	'2 initialise db
	'3. log version number
	
	
	SQLDataBasePath = File.DirInternal   '*Note1  - why DirInternal ?

	SQLDateBaseName = "SQLlite1.3.db"  ' Stored initially in FileDirAssets
	

	If File.Exists(SQLDataBasePath, SQLDateBaseName) = False Then
		Log("Starter - OK - File not exist internally first time , copying from assets")
		'	File.Delete(SQLDataBasePath, SQLDateBaseName) ' only for testing, removes the database
		File.Copy(File.DirAssets, SQLDateBaseName, SQLDataBasePath, SQLDateBaseName)
		Log("Starter - OK - File copied from assets")
		'SQLDataBasePath = DBUtils.CopyDBFromAssets(SQLDateBaseName)	*Note2
	End If
	
	' see Note3
	' External Folder/Directory if need to use from there due to size of db or backup for examnple
'	For example: DirRootExternal & "/EastBreeze"
'	Don't forget to create the subdirectory:  File.MakeDir(File.DirRootExternal, "EastBreeze")
'	example code in the Starter module:
'	MyFolder = RuntimePermissions.GetSafeDirDefaultExternal("EastBreeze")
'	If File.Exists(MyFolder, SQLDateBaseName) = False Then
'		File.Copy(File.DirAssets, SQLDateBaseName, MyFolder, SQLDateBaseName)
'	End If
	Log("Starter - OK - Sql Initialised")
'	SQL1.Initialize(MyFolder, SQLDateBaseName, True)
		
	SQL1.Initialize(SQLDataBasePath, SQLDateBaseName, True)
	
	'
'	Dim SQLversion As Int
'	SQLversion = DBUtils.getDBVersion(SQL1)   'Please note you need to create a database table called DBversion with a field called version and enter your database version number asa row in this tAble
'	Log("Starter - OK - DB version is " & SQLversion)
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

'Sub SQLInit
'	Private query As String
'	
'	query = "CREATE TABLE Stock (Number INTEGER, ProductID INTEGER, Date INTEGER)"
'	SQL1.ExecNonQuery(query)	
'	query = "INSERT INTO Stock VALUES (5, 1, 1092941466000)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Stock VALUES (10, 2, 1265583600000)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Stock VALUES (15, 4, 1328655600000)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Stock VALUES (2, 5, 1297119600000)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Stock VALUES (20, 3, 1391814000000)"
'	SQL1.ExecNonQuery(query)	
'	query = "INSERT INTO Stock VALUES (15, 6, " & DateTime.Now & ")"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Stock VALUES (8, 7, 1391814000000)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Stock VALUES (13, 9, " & DateTime.Now & ")"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Stock VALUES (4, 10, " & DateTime.Now & ")"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Stock VALUES (2, 11, 1328655600000)"
'	SQL1.ExecNonQuery(query)
'	
'	query = "CREATE TABLE Products (Name TEXT, Price REAL, SupplierID INTEGER)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Brake', 350.123, 1)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Brake', 175.657, 3)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Brake', 225, 4)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Brake', 270, 5)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Brake', 250, 6)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Exhaust pipe', 150, 2)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Exhaust pipe', 250, 1)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Exhaust pipe', 175, 4)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Exhaust pipe', 175, 3)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Exhaust pipe', 175, 5)"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Products VALUES ('Exhaust pipe', 175, 6)"
'	SQL1.ExecNonQuery(query)
'		
'	query = "CREATE TABLE Suppliers (Name TEXT, Address TEXT, City TEXT)" 
'	SQL1.ExecNonQuery(query)		
'	query = "INSERT INTO Suppliers VALUES ('Renault','Rue de la Gare 30', 'Paris')"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Suppliers VALUES ('Ford', 'Main street 11', 'Detroit')"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Suppliers VALUES ('VW', 'Hauptstrasse 3', 'Wolfsburg')"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Suppliers VALUES ('Opel', 'Bahnhofsplatz 1', 'Rüsselsheim')"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Suppliers VALUES ('PSA', 'Avenue de la Grande Armée 75', 'Paris')"
'	SQL1.ExecNonQuery(query)
'	query = "INSERT INTO Suppliers VALUES ('Fiat', 'Corso Giulio Cesare 360', 'Torino')"
'	SQL1.ExecNonQuery(query)
'End Sub


#Region Notes

'*Note1
'see B4xBasicLanguage section 4.12 refresher
							
							'Subject to space use 
					
							'	File.DirAssets
										'	The assets folder includes the files that were added with the File manager in the IDE.
										'	It's the Files folder in the project folder.
										'	These files are read-only !
										'	You can Not create new files in this folder (which Is actually located inside the apk File).
										'	If you have a database File in the Dir.Assets folder you need To copy it To another folder before you
										'	can use it.
							'	
							'	File.DirInternal / File.DirInternalCache
										'These two folders are stored in the Main memory of the device And are Private To your Application.
										'Other applications cannot access these files.
										'The cache folder may get deleted by the OS If it needs more space.
							'External storage.
										'You should use the RuntimePermissions library To get the best folder with:
										'MyFolder = RuntimePermissions.GetSafeDirDefaultExternal(SubFolder As String)
										'Returns the path To the app's default folder on the secondary storage device.
										'The path To File.DirInternal will be returned If there Is no secondary storage available.
										'It Is a better alternative To File.DirDefaultExternal.
										'On Android 4.4+ no permission Is required To access this folder.
										'SubFolder - A sub folder that will be created for your app. Pass an empty string if not needed.
							'
							'File.DirRootExternal
										'The storage card root folder. In most cases this is an internal storage card and not an external SD
										'card.
							'File.DirDefaultExternal
										'The default folder for your application in the SD card.
										'The folder is: <storage card>/Android/data/<package>/files/
										'It will be created if required.
										'Note that calling any of the two above properties will add the EXTERNAL_STORAGE permission
										'to your application.
										'Tip: You can check if there is a storage card and whether it is available with
										'File.ExternalReadable and File.ExternalWritable
										
							
								'To check If a File already exists use:
										'File.Exists ( Dir As String, FileName As String)
										'Returns True If the File exists And False If Not.
'*Note2
'from dbutils2 class
		' sub CopyDBFromAssets
		'Copies a database file that was added in the Files tab. The database must be copied to a writable location.
		'This method copies the database to the storage card. If the storage card is not available the file is copied to the internal folder.
		'The target folder is returned.
		'If the database file already exists then no copying is done.


'*Note3
	' Guide B4xSQLiteDatabase 1.4
'	If you add a default database To your project in the files TAB, it Is located in the DirAssets
'	folder. Databases cannot be accessed in DirAssets even If it's only for reading.
'	Therefore, you must copy it To another folder.
'	Example in the SQLiteLight1 programs.

'DroidLyon - Note that DirRootExternal is persistent !

'	With DirRootExternal you can also add a subdirectory.
'	For example: DirRootExternal & "/MyDatabase"
'	Don't forget to create the subdirectory:  File.MakeDir(File.DirRootExternal, "MyDatabase")
'	example code in the Starter module:
'	If File.Exists(File.DirRootExternal, "Database.db") = False Then
'		File.Copy(File.DirAssets, "Database", File.DirRootExternal, "Database.db")
'	End If
'	SQL1.Initialize(File.DirRootExternal, "Database.db", True)

#End Region



